/*
	Copyright (C) 2020-2021 Reiko Asakura. All Rights Reserved.

	Music Premium
*/

#include <kernel/constant.h>
#include <libdbg.h>

#include "module.h"

/* ARGSUSED */
int get_export(const char *modname, uint32_t libnid, uint32_t funcnid, uintptr_t *func, const char *name) {
	int ret = module_get_export_func(KERNEL_PID, modname, libnid, funcnid, func);
	if (ret == 0) {
		SCE_DBG_LOG_INFO("Found export %s %p", name, *func);
	} else {
		SCE_DBG_LOG_ERROR("Failed to find export %s 0x%08X", name, ret);
	}
	return ret;
}

int get_module(SceUID pid, const char *name, tai_module_info_t *info) {
	int ret = module_get_by_name_nid(pid, name, TAI_IGNORE_MODULE_NID, info);
	if (ret == 0) {
		SCE_DBG_LOG_INFO("Found module %s uid 0x%08X fingerprint 0x%08X", name, info->modid, info->module_nid);
	} else {
		SCE_DBG_LOG_ERROR("Failed to find module %s 0x%08X", name, ret);
	}
	return ret;
}
