/*
	Copyright (C) 2020-2021 Reiko Asakura. All Rights Reserved.

	Music Premium
*/

#ifndef PATCH_H_
#define PATCH_H_

#include <taihen.h>

#define HOOK_NEXT(func, ...) TAI_NEXT(func##_hook, func##_hook_ref, ##__VA_ARGS__)

#define HOOK_EXPORT(module, libnid, funcnid, func) \
	hook_export(module, libnid, funcnid, func##_hook, &func##_hook_id, &func##_hook_ref, #func)

#define HOOK_ABS(dest, func) hook_abs(dest, func##_hook, &func##_hook_id, &func##_hook_ref, #func)

#define UNHOOK(func) unhook(&func##_hook_id, func##_hook_ref, #func)

#define INJECT_ABS(dest, src, size, name) inject_abs(dest, src, size, &name##_patch_id, #name)

#define UNINJECT(name) uninject(&name##_patch_id, #name)

int hook_export(
	const char *module, uint32_t libnid, uint32_t funcnid, const void *func,
	SceUID *hook_id, tai_hook_ref_t *hook_ref, const char *name);

int hook_abs(void *dest, const void *func, SceUID *hook_id, tai_hook_ref_t *hook_ref, const char *name);

int unhook(SceUID *hook_id, tai_hook_ref_t hook_ref, const char *name);

int inject_abs(void *dest, const void *src, size_t size, SceUID *inject_id, const char *name);

int uninject(SceUID *inject_id, const char *name);

#endif
